
import java.lang.*;
import java.io.*;
import java.net.*;

public class vodclient implements Runnable{

  static globals jva;
  public static int head;
  public static int tail;
  public static int empty;
  public static byte buffer[];

  public static void setupConnections(){

    try{
      jva.dataSock = new Socket("128.230.14.106", 2005);
    }
    catch(Exception e){System.out.println("Exception while data connecting.");}

    try{
      jva.commandSock = new Socket("128.230.14.106", 2006);
    }
    catch(Exception e){System.out.println("Exception while command connecting.");}

    try{
      jva.data = new BufferedInputStream(jva.dataSock.getInputStream());
    }
    
    catch(Exception e){System.out.println("Exception while inputstream querying");}
    
    try{
      jva.cmdin = jva.commandSock.getInputStream();
    }
    
    catch(Exception e){System.out.println("Exception while inputstream querying command");}
    
    try{
      jva.cmdout = jva.commandSock.getOutputStream();
    }
    
    catch(Exception e){System.out.println("Exception while outputstream querying command");}
    
    head = 0;
    tail = 0;
    buffer = new byte[32768];
    empty = 32768;
  }

  public static void sendCommand(int command){

    byte buf[];
    int len;
    
    switch(command){
      
    case 1: /* VODStop */
      buf = new byte[1];
      buf[0] = (byte) (jva.NPACVodJava.VODStop - jva.NPACVodJava.VODBaseMsg);
      try{
	jva.cmdout.write(buf, 0, 1);
      }
      catch(Exception e){System.out.println("Error sending stop command.");}
      /* Wait for ack */
      waitForReply(jva.NPACVodJava.VODAckStopMessage);
      break;
      
    case 2: /* VODPlay */
      buf = new byte[1];
      buf[0] = (byte) (jva.NPACVodJava.VODPlay - jva.NPACVodJava.VODBaseMsg);
      try{
	jva.cmdout.write(buf, 0, 1);
      }
      catch(Exception e){System.out.println("Error sending Play command.");}
      break;
      
    case 7: /* VODLoadMovie */
      len = jva.fileName.length();
      buf = new byte[len + 2];
      buf[0] = (byte) (jva.NPACVodJava.VODLoadMovie - jva.NPACVodJava.VODBaseMsg);
      buf[1] = (byte) len;
      jva.fileName.getBytes(0, len, buf, 2);
      try{
	jva.cmdout.write(buf, 0, len + 2);
      }
      catch(Exception e){System.out.println("Error sending LoadMovie command.");}
      break;

    case 16: /* VODSeekToOffset */
      break;

    }
    
  }

  static void waitForReply(int msg){

    int ret;
    
    while(true){
      try{
	ret = jva.cmdin.read();
      }
      catch(Exception e){System.out.println("Excpetion while waiting for reply."); ret = jva.NPACVodJava.VODBaseMsg;}
      if (ret == (msg - jva.NPACVodJava.VODBaseMsg))
	break;
      else
	System.out.println("Got command " + (ret + jva.NPACVodJava.VODBaseMsg)  + " Expected " + msg);
    }
    
    System.out.println("Recieved Reply " + ret);
  }

  public static void sleepFor(int t){

    try{
      jva.net.sleep(t);
    }
    catch(Exception e){};
  }

  public void run(){
    
    int netRead;
    int temp;
    int temp1;
    boolean terminate;

    System.out.println("In VodClient run.");
    terminate = false;

    while (jva.net != null){
      while (empty == 0){
	if (tail < head){
	  empty = 32768 - head;
	  empty += tail;
	}
	else
	  empty = tail - head;
/*      System.out.println("Waiting for buffer to be read.");*/
	sleepFor(1800);
      }
      
      if ((head + empty) <= 32768){
/*      System.out.println("Reading from " + head + " " + empty + " bytes.");*/
	
	try{
	  if (!terminate)
	    netRead = jva.data.read(buffer, head, empty);
	  else
	    netRead = 0;
	}
	catch(Exception e){System.out.println("Exception in circular buffer read."); netRead = 0; terminate = true;}
      }
      else{
	temp = 32768 - head;
	try{
/*        System.out.println("(1) Reading from " + head + " " + temp + " bytes.");*/
	  if (!terminate)
	    netRead = jva.data.read(buffer, head, temp);
	  else
	    netRead = 0;
	}
	catch(Exception e){System.out.println("Exception in circular buffer read."); netRead = 0; terminate = true;}
      }
/*      System.out.println("Read " + netRead + " bytes.");*/

      head += netRead;
      if (head >= 32768)
	head -= 32768;

      if (tail < head){
	empty = 32768 - head;
	empty += tail;
      }
      else
	empty = tail - head;
      
/*      System.out.println("Empty bytes are " + empty);*/
      if (terminate){
	sleepFor(20000);
      }
      /* Should check if there are any bytes waiting to be read on the command
	 input stream. */
    }
    System.out.println("Exiting vodclient run.");
  }


}
